/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleCampaignManagerConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleCampaignManagerConnectorFormAllOf{}

// GoogleCampaignManagerConnectorFormAllOf struct for GoogleCampaignManagerConnectorFormAllOf
type GoogleCampaignManagerConnectorFormAllOf struct {
	// Authorizer ID
	OAuthId *string `json:"oAuthId,omitempty"`
	// Label of the source
	Label *string `json:"label,omitempty"`
	// Amazon Ads Profile ID
	ProfileId *string `json:"profileId,omitempty"`
	// Amazon Ads Report Type
	ReportType *string `json:"reportType,omitempty"`
	// Data range expression
	DateRangeExpression *string `json:"dateRangeExpression,omitempty"`
}

// NewGoogleCampaignManagerConnectorFormAllOf instantiates a new GoogleCampaignManagerConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleCampaignManagerConnectorFormAllOf() *GoogleCampaignManagerConnectorFormAllOf {
	this := GoogleCampaignManagerConnectorFormAllOf{}
	return &this
}

// NewGoogleCampaignManagerConnectorFormAllOfWithDefaults instantiates a new GoogleCampaignManagerConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleCampaignManagerConnectorFormAllOfWithDefaults() *GoogleCampaignManagerConnectorFormAllOf {
	this := GoogleCampaignManagerConnectorFormAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleCampaignManagerConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleCampaignManagerConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *GoogleCampaignManagerConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *GoogleCampaignManagerConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *GoogleCampaignManagerConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *GoogleCampaignManagerConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetProfileId returns the ProfileId field value if set, zero value otherwise.
func (o *GoogleCampaignManagerConnectorFormAllOf) GetProfileId() string {
	if o == nil || IsNil(o.ProfileId) {
		var ret string
		return ret
	}
	return *o.ProfileId
}

// GetProfileIdOk returns a tuple with the ProfileId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerConnectorFormAllOf) GetProfileIdOk() (*string, bool) {
	if o == nil || IsNil(o.ProfileId) {
		return nil, false
	}
	return o.ProfileId, true
}

// HasProfileId returns a boolean if a field has been set.
func (o *GoogleCampaignManagerConnectorFormAllOf) HasProfileId() bool {
	if o != nil && !IsNil(o.ProfileId) {
		return true
	}

	return false
}

// SetProfileId gets a reference to the given string and assigns it to the ProfileId field.
func (o *GoogleCampaignManagerConnectorFormAllOf) SetProfileId(v string) {
	o.ProfileId = &v
}

// GetReportType returns the ReportType field value if set, zero value otherwise.
func (o *GoogleCampaignManagerConnectorFormAllOf) GetReportType() string {
	if o == nil || IsNil(o.ReportType) {
		var ret string
		return ret
	}
	return *o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerConnectorFormAllOf) GetReportTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ReportType) {
		return nil, false
	}
	return o.ReportType, true
}

// HasReportType returns a boolean if a field has been set.
func (o *GoogleCampaignManagerConnectorFormAllOf) HasReportType() bool {
	if o != nil && !IsNil(o.ReportType) {
		return true
	}

	return false
}

// SetReportType gets a reference to the given string and assigns it to the ReportType field.
func (o *GoogleCampaignManagerConnectorFormAllOf) SetReportType(v string) {
	o.ReportType = &v
}

// GetDateRangeExpression returns the DateRangeExpression field value if set, zero value otherwise.
func (o *GoogleCampaignManagerConnectorFormAllOf) GetDateRangeExpression() string {
	if o == nil || IsNil(o.DateRangeExpression) {
		var ret string
		return ret
	}
	return *o.DateRangeExpression
}

// GetDateRangeExpressionOk returns a tuple with the DateRangeExpression field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerConnectorFormAllOf) GetDateRangeExpressionOk() (*string, bool) {
	if o == nil || IsNil(o.DateRangeExpression) {
		return nil, false
	}
	return o.DateRangeExpression, true
}

// HasDateRangeExpression returns a boolean if a field has been set.
func (o *GoogleCampaignManagerConnectorFormAllOf) HasDateRangeExpression() bool {
	if o != nil && !IsNil(o.DateRangeExpression) {
		return true
	}

	return false
}

// SetDateRangeExpression gets a reference to the given string and assigns it to the DateRangeExpression field.
func (o *GoogleCampaignManagerConnectorFormAllOf) SetDateRangeExpression(v string) {
	o.DateRangeExpression = &v
}

func (o GoogleCampaignManagerConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleCampaignManagerConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.ProfileId) {
		toSerialize["profileId"] = o.ProfileId
	}
	if !IsNil(o.ReportType) {
		toSerialize["reportType"] = o.ReportType
	}
	if !IsNil(o.DateRangeExpression) {
		toSerialize["dateRangeExpression"] = o.DateRangeExpression
	}
	return toSerialize, nil
}

type NullableGoogleCampaignManagerConnectorFormAllOf struct {
	value *GoogleCampaignManagerConnectorFormAllOf
	isSet bool
}

func (v NullableGoogleCampaignManagerConnectorFormAllOf) Get() *GoogleCampaignManagerConnectorFormAllOf {
	return v.value
}

func (v *NullableGoogleCampaignManagerConnectorFormAllOf) Set(val *GoogleCampaignManagerConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleCampaignManagerConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleCampaignManagerConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleCampaignManagerConnectorFormAllOf(val *GoogleCampaignManagerConnectorFormAllOf) *NullableGoogleCampaignManagerConnectorFormAllOf {
	return &NullableGoogleCampaignManagerConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableGoogleCampaignManagerConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleCampaignManagerConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
